#ifndef SLL_H
#define SLL_H

#include <iostream>
#include "Node.h"
using namespace std;

template <class U>
class SLL {
    Node<U> * headPtr;
    int size;

public:
    // default constructor

    SLL() {
        headPtr = nullptr;
        size = 0;
    }

    // destructor    

    ~SLL() {

        Node<U> *temp = nullptr;
        int i = size - 1;
        temp = headPtr + i;

        while (i > 0) {
            delete temp;
            i--;
            if (i > 0)temp = headPtr + i;
        }
        delete headPtr;

        size = 0;
    }

    Node<U>* getHeadPtr() {
        return headPtr;
    }

    // insert (item1, item2) to the list

    bool insert(U item1, U item2) {
        Node<U> *temp = nullptr;
        Node<U> *temp_previous = nullptr;
        temp = headPtr;
        while (temp != nullptr) {
            temp_previous = temp;
            temp = temp->next;
        }
        if (temp_previous == nullptr) {
            headPtr = new Node<U>;
            headPtr->SSN = item1;
            headPtr->name = item2;
            headPtr->next = nullptr;
        } else {
            temp = new Node<U>;
            temp_previous->next = temp;
            temp->SSN = item1;
            temp->name = item2;
            temp->next = nullptr;
        }
        size++;
        cout << true << " i " << size << endl;
        return true;
    }

    // if find the item1 value, return the pointer to the node
    // otherwise, return nullptr

    Node<U>* search(U item1) {
        bool t = false;
        Node<U> *temp = nullptr;
        temp = headPtr;
        while (temp != nullptr) {
            if (temp->SSN == item1) {
                t = true;
                break;
            }
            temp = temp->next;
        }
        cout << t << " r " << size << endl;
        if (t == true)return temp;
        else return nullptr;
    }

    // remove the node with key value: item1

    bool remove(U item1) {

        if (size == 0)return false;
        bool t = false;
        Node<U> *temp = nullptr;
        Node<U> *temp_previous = nullptr;
        temp = headPtr;
        while (temp != nullptr) {
            if (temp->SSN != item1)temp_previous = temp;
            else if (temp->SSN == item1) {
                if (temp_previous != nullptr) {
                    temp_previous->next = temp->next;
                }
                delete temp;
                t = true;
                size--;
                break;
            }
            temp = temp->next;
        }
        cout << t << " d " << size << endl;
        return t;
    }

    int getSize() {
        return size;
    }

    // display the SSN values of each node in the linked list

    void display() {
        Node<U>* temp;
        temp = headPtr;
        while (temp != nullptr) {
            cout << temp->SSN << endl;
            temp = temp->next;
        }
    }
};



#endif // SLL_H
