#ifndef HASHTABLE_H
#define HASHTABLE_H

#include <iostream>
#include <string>
#include <string.h>
#include <cstdio>
#include <cstdlib>
#include "SLL.h"
#include "node.h"

using namespace std;

template <class V>
class HashTable {
    long tableSize; // table size

    SLL<V>* table;

public:
    // default constructor, which uses default table size 3

    HashTable() {
        tableSize = 3;
        table = new SLL<V>[tableSize];
    }

    // constructor, which use size as the table size

    HashTable(long size) {
        tableSize = size;
        table = new SLL<V>[tableSize];
    }

    ~HashTable() {
        tableSize = 0;
        delete table;
    }
    // search item in the table
    // if found, return true; otherwise, return false

    bool find(V item) {
        string sitem = static_cast<string> (item);
        char x[10];
        x[9] = '\0';
        strncpy(x, (sitem.c_str()), 9);
        char w[10];
        w[9] = '\0';
        strncpy(w, x, 9);
        long l = atol(w);
        int key = l % tableSize;
        bool t = table[key].search(item);
        return t;
    }

    // insert (item1, item2) to the table
    // use item1 as the key
    // if inserted, return true
    // otherwise, return false

    bool insert(V item1, V item2) {
        string sitem = static_cast<string> (item1);
        char x[10];
        x[9] = '\0';
        strncpy(x, (sitem.c_str()), 9);
        char w[10];
        w[9] = '\0';
        strncpy(w, x, 9);
        long l = atol(w);
        int key = l % tableSize;
        bool t = table[key].insert(item1,item2);
        return t;
    }

    // delete the pair whose key value is item
    // if deleted, return true
    // otherwise, return false 

    bool erase(V item) {
        if (false == find(item))return false;
        string sitem = static_cast<string> (item);
        char x[10];
        x[9] = '\0';
        strncpy(x, (sitem.c_str()), 9);
        char w[10];
        w[9] = '\0';
        strncpy(w, x, 9);
        long l = atol(w);
        int key = l % tableSize;
        bool t = table[key].remove(item);
        return t;
    }

    // return the total number of nodes in the hash table    

    int getSize() {
        return tableSize;
    }

};

#endif // HASHTABLE_H
